
_read_ds1307:

;dc.c,19 :: 		unsigned short read_ds1307(unsigned short address)
;dc.c,22 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;dc.c,23 :: 		I2C1_Wr(0xD0); //address 0x68 followed by direction bit (0 for write, 1 for read) 0x68 followed by 0 --> 0xD0
	MOVLW      208
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;dc.c,24 :: 		I2C1_Wr(address);
	MOVF       FARG_read_ds1307_address+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;dc.c,25 :: 		I2C1_Repeated_Start();
	CALL       _I2C1_Repeated_Start+0
;dc.c,26 :: 		I2C1_Wr(0xD1); //0x68 followed by 1 --> 0xD1
	MOVLW      209
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;dc.c,27 :: 		r_data=I2C1_Rd(0);
	CLRF       FARG_I2C1_Rd_ack+0
	CALL       _I2C1_Rd+0
	MOVF       R0+0, 0
	MOVWF      read_ds1307_r_data_L0+0
;dc.c,28 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;dc.c,29 :: 		return(r_data);
	MOVF       read_ds1307_r_data_L0+0, 0
	MOVWF      R0+0
;dc.c,30 :: 		}
	RETURN
; end of _read_ds1307

_BCD2UpperCh:

;dc.c,33 :: 		unsigned char BCD2UpperCh(unsigned char bcd)
;dc.c,35 :: 		return ((bcd >> 4) + '0');
	MOVF       FARG_BCD2UpperCh_bcd+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVLW      48
	ADDWF      R0+0, 1
;dc.c,36 :: 		}
	RETURN
; end of _BCD2UpperCh

_BCD2LowerCh:

;dc.c,39 :: 		unsigned char BCD2LowerCh(unsigned char bcd)
;dc.c,41 :: 		return ((bcd & 15) + '0');
	MOVLW      15
	ANDWF      FARG_BCD2LowerCh_bcd+0, 0
	MOVWF      R0+0
	MOVLW      48
	ADDWF      R0+0, 1
;dc.c,42 :: 		}
	RETURN
; end of _BCD2LowerCh

_main:

;dc.c,61 :: 		void main()
;dc.c,63 :: 		I2C1_Init(100000); //DS1307 I2C is running at 100KHz
	MOVLW      10
	MOVWF      SSPADD+0
	CALL       _I2C1_Init+0
;dc.c,65 :: 		C1ON_bit = 0; // Disable comparators
	BCF        C1ON_bit+0, 7
;dc.c,66 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, 7
;dc.c,68 :: 		ANSEL  = 0;       // configure AN pins as digital I/O
	CLRF       ANSEL+0
;dc.c,69 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;dc.c,70 :: 		TRISB = 0;
	CLRF       TRISB+0
;dc.c,72 :: 		TRISA = 1;
	MOVLW      1
	MOVWF      TRISA+0
;dc.c,73 :: 		PORTA = 0;
	CLRF       PORTA+0
;dc.c,75 :: 		trisd=0;
	CLRF       TRISD+0
;dc.c,76 :: 		portd=0;
	CLRF       PORTD+0
;dc.c,78 :: 		Lcd_Init();                        // Initialize LCD
	CALL       _Lcd_Init+0
;dc.c,79 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;dc.c,80 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;dc.c,81 :: 		Lcd_out(1,1,"Time:");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_dc+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;dc.c,82 :: 		Lcd_out(2,1,"Date:");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_dc+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;dc.c,84 :: 		do
L_main0:
;dc.c,88 :: 		second = read_ds1307(0);
	CLRF       FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _second+0
	CLRF       _second+1
;dc.c,89 :: 		minute = read_ds1307(1);
	MOVLW      1
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _minute+0
	CLRF       _minute+1
;dc.c,90 :: 		hour = read_ds1307(2);
	MOVLW      2
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _hour+0
	CLRF       _hour+1
;dc.c,91 :: 		dday = read_ds1307(3);
	MOVLW      3
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _dday+0
	CLRF       _dday+1
;dc.c,92 :: 		day = read_ds1307(4);
	MOVLW      4
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _day+0
	CLRF       _day+1
;dc.c,93 :: 		month = read_ds1307(5);
	MOVLW      5
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _month+0
	CLRF       _month+1
;dc.c,94 :: 		year = read_ds1307(6);
	MOVLW      6
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _year+0
	CLRF       _year+1
;dc.c,97 :: 		time[0] = BCD2UpperCh(hour);
	MOVF       _hour+0, 0
	MOVWF      FARG_BCD2UpperCh_bcd+0
	CALL       _BCD2UpperCh+0
	MOVF       R0+0, 0
	MOVWF      _time+0
;dc.c,98 :: 		time[1] = BCD2LowerCh(hour);
	MOVF       _hour+0, 0
	MOVWF      FARG_BCD2LowerCh_bcd+0
	CALL       _BCD2LowerCh+0
	MOVF       R0+0, 0
	MOVWF      _time+1
;dc.c,99 :: 		time[3] = BCD2UpperCh(minute);
	MOVF       _minute+0, 0
	MOVWF      FARG_BCD2UpperCh_bcd+0
	CALL       _BCD2UpperCh+0
	MOVF       R0+0, 0
	MOVWF      _time+3
;dc.c,100 :: 		time[4] = BCD2LowerCh(minute);
	MOVF       _minute+0, 0
	MOVWF      FARG_BCD2LowerCh_bcd+0
	CALL       _BCD2LowerCh+0
	MOVF       R0+0, 0
	MOVWF      _time+4
;dc.c,101 :: 		time[6] = BCD2UpperCh(second);
	MOVF       _second+0, 0
	MOVWF      FARG_BCD2UpperCh_bcd+0
	CALL       _BCD2UpperCh+0
	MOVF       R0+0, 0
	MOVWF      _time+6
;dc.c,102 :: 		time[7] = BCD2LowerCh(second);
	MOVF       _second+0, 0
	MOVWF      FARG_BCD2LowerCh_bcd+0
	CALL       _BCD2LowerCh+0
	MOVF       R0+0, 0
	MOVWF      _time+7
;dc.c,104 :: 		date[0] = BCD2UpperCh(day);
	MOVF       _day+0, 0
	MOVWF      FARG_BCD2UpperCh_bcd+0
	CALL       _BCD2UpperCh+0
	MOVF       R0+0, 0
	MOVWF      _date+0
;dc.c,105 :: 		date[1] = BCD2LowerCh(day);
	MOVF       _day+0, 0
	MOVWF      FARG_BCD2LowerCh_bcd+0
	CALL       _BCD2LowerCh+0
	MOVF       R0+0, 0
	MOVWF      _date+1
;dc.c,106 :: 		date[3] = BCD2UpperCh(month);
	MOVF       _month+0, 0
	MOVWF      FARG_BCD2UpperCh_bcd+0
	CALL       _BCD2UpperCh+0
	MOVF       R0+0, 0
	MOVWF      _date+3
;dc.c,107 :: 		date[4] = BCD2LowerCh(month);
	MOVF       _month+0, 0
	MOVWF      FARG_BCD2LowerCh_bcd+0
	CALL       _BCD2LowerCh+0
	MOVF       R0+0, 0
	MOVWF      _date+4
;dc.c,108 :: 		date[6] = BCD2UpperCh(year);
	MOVF       _year+0, 0
	MOVWF      FARG_BCD2UpperCh_bcd+0
	CALL       _BCD2UpperCh+0
	MOVF       R0+0, 0
	MOVWF      _date+6
;dc.c,109 :: 		date[7] = BCD2LowerCh(year);
	MOVF       _year+0, 0
	MOVWF      FARG_BCD2LowerCh_bcd+0
	CALL       _BCD2LowerCh+0
	MOVF       R0+0, 0
	MOVWF      _date+7
;dc.c,111 :: 		if(ap)
	MOVF       _ap+0, 0
	IORWF      _ap+1, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main3
;dc.c,113 :: 		time[9] = 'P';
	MOVLW      80
	MOVWF      _time+9
;dc.c,114 :: 		time[10] = 'M';
	MOVLW      77
	MOVWF      _time+10
;dc.c,115 :: 		}
	GOTO       L_main4
L_main3:
;dc.c,118 :: 		time[9] = 'A';
	MOVLW      65
	MOVWF      _time+9
;dc.c,119 :: 		time[10] = 'M';
	MOVLW      77
	MOVWF      _time+10
;dc.c,120 :: 		}
L_main4:
;dc.c,123 :: 		Lcd_out(1, 6, time);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      6
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _time+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;dc.c,124 :: 		Lcd_out(2, 6, date);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      6
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _date+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;dc.c,125 :: 		Delay_ms(100);
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_main5:
	DECFSZ     R13+0, 1
	GOTO       L_main5
	DECFSZ     R12+0, 1
	GOTO       L_main5
	NOP
	NOP
;dc.c,128 :: 		}while(1);
	GOTO       L_main0
;dc.c,129 :: 		}
	GOTO       $+0
; end of _main
